function Parametros(localStorageEngine, restEngine) {

	this.paramgeral = function() {

		return restEngine.post('product#/crud/paramgeral', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "NRORG",
					"operator": "=",
					"value": localStorageEngine.getLocalVar("NRORG")
				}
			]
		});

	};

    this.parasupri = function(cdfilial){

        return restEngine.post('product#/crud/parasupri', {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": localStorageEngine.getLocalVar("NRORG")
                },
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
                }
            ]
        });

    };

    this.parcmpsup = function(cdfilial){

        return restEngine.post('product#/crud/parcmpsup', {
            "requestType": "FilterData",
            "filter": [
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": localStorageEngine.getLocalVar("NRORG")
                },
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
                }
            ]
        });

    };

	this.paramplaneja = function() {

		return restEngine.post('product#/crud/paramplaneja', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "NRORG",
					"operator": "=",
					"value": localStorageEngine.getLocalVar("NRORG")
				},
				{
					"name": "CDFILIAL",
					"operator": "=",
					"value": localStorageEngine.getLocalVar("CDFILIAL")
				}
			]
		});

	};

	this.retornaNivelMaxProduto = function(){
        mascaraProduto = getLocalVar('CDPICTPROD');
        nivelMax = mascaraProduto.split('.').length;

        return nivelMax;
    };

    this.retornaNivelMaxPrato = function(){
        mascaraPrato = getLocalVar('CDPICTPRAT');
        nivelMax = mascaraPrato.split('.').length;

        return nivelMax;
    };

	this.paramfilial = function() {
		var nrorg = arguments[0] || localStorageEngine.getLocalVar("NRORG");
		var cdfilial = arguments[1] || localStorageEngine.getLocalVar("CDFILIAL");
		return restEngine.post('product#/crud/paramfilial', {
			"requestType": "FilterData",
			"filter": [
				{
					"name": "NRORG",
					"operator": "=",
					"value": nrorg
				},
				{
					"name": "CDFILIAL",
					"operator": "=",
					"value": cdfilial
				}
			]
		});

	};

	this.retornaDataProcessamento = function(cdfilial, nrorg) {

		return this.paramfilial(nrorg, cdfilial).then(function(callback) {

			var dtprocessa = callback.dataset.paramfilial[0].DTPROCESSA;

			if(dtprocessa) {
				return moment(dtprocessa,'DD/MM/YYYY HH:mm:ss').format('L');
			} else {
				return moment().format('L');
			}

		});

	};
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Parametros', Parametros);
});
